#pragma once

#include "PreCompiledHeaders.hh"
#include "Lib/Ass/StyleProperties.hh"

namespace Vivy::Ass
{
class Line;

class Syl final {
private:
    QString content;
    StyleProperties styleProperties;
    quint64 duration{ 0 };

public:
    Line *const parentLine;

public:
    enum class ConstructMode {
        Raw,        // Don't read ASS tags
        ReadAssTags // Read ass tags
    };

    explicit Syl(const Syl &) noexcept = default;
    explicit Syl(Line *const, const QString &,
                 ConstructMode mode = ConstructMode::ReadAssTags) noexcept;

    Syl &operator=(const Syl &) = delete;
    ~Syl() noexcept             = default;

    QString getContent() const noexcept;

private:
    static quint64 getDurationFromString(const QString &) noexcept;
};
}
