#include "PreCompiledHeaders.hh"
#include "Lib/Document/CRTPSubDocument.hh"
#include "Lib/JsonBuilder.hh"

using namespace Vivy;

// Init a video sub-document from a file
void
VideoSubDocument::initFromPath(const QString &path)
{
    contextPtr.reset(new VideoContext(path)); // May throw
}

QString
VideoSubDocument::getElementName() const noexcept
{
    return "VideoSubDocument";
}

QJsonDocument
VideoSubDocument::getProperties() const noexcept
{
    return JsonBuilder::createOrderedJsonDocument({
        { "Video context", contextPtr->getProperties().object() },
        { "File", filePath },
    });
}
