#pragma once

#include "PreCompiledHeaders.hh"
#include "Lib/Utils.hh"

namespace Vivy
{
// Struct used to englobe all json build facilities. This is a class used as a
// private-able namespace that can't be 'using' and thus create unreadable
// code. You can't build this thing, everything is static inside.
struct JsonBuilder final {
    VIVY_UNMOVABLE_OBJECT(JsonBuilder)

    static QJsonArray
    createOrderedJsonObject(std::initializer_list<QPair<QString, QJsonValue>> elements) noexcept;

    static QJsonDocument
    createOrderedJsonDocument(std::initializer_list<QPair<QString, QJsonValue>> elements) noexcept;

    template <PropertyConstViewable T> static QPair<QString, QJsonValue>
    getSubDocumentJson(const QString &name, std::shared_ptr<T> subDocPtr) noexcept
    {
        if (subDocPtr == nullptr)
            return QPair{ name, QJsonValue() };
        else
            return QPair{ name, subDocPtr->getProperties().object() };
    }

private:
    JsonBuilder() noexcept {}
};
}
