#pragma once

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include "PreCompiledHeaders.hh"
#include "VivyApplication.hh"
#include "Lib/Utils.hh"

namespace Vivy
{
class MpvContainer;

class MpvControls final : public QWidget {
    Q_OBJECT
    VIVY_UNMOVABLE_OBJECT(MpvControls)

private:
    MpvContainer *mpv{ nullptr };
    chrono::seconds timeDuration;
    chrono::seconds timePosition;
    int askedSliderPosition{ 0 };

    const QIcon playIcon{ VIVY_ICON_PLAY };
    const QIcon pauseIcon{ VIVY_ICON_PAUSE };

public:
    explicit MpvControls(MpvContainer *mpv, QWidget *parent) noexcept;
};
}
