#pragma once

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include "PreCompiledHeaders.hh"
#include "Lib/Utils.hh"
#include "UI/DocumentViews/TimingBar.hh"
#include "UI/DocumentViews/TimingScene.hh"

namespace Vivy
{
class TimingView final : public QGraphicsView {
    Q_OBJECT

    static inline constexpr int wheelAngleToScrollRatio = 5;

public:
    static inline constexpr QColor startColour = QColor(127, 0, 127);
    static inline constexpr QColor endColour   = QColor(0, 127, 0);

    explicit TimingView(QImage, quint64, QWidget * = nullptr) noexcept;
    ~TimingView() noexcept override = default;

    void wheelEvent(QWheelEvent *) noexcept override;

private:
    TimingScene *scene{ nullptr };

public slots:
    void mousePressEvent(QMouseEvent *event) noexcept override;
    void moveScrollBarToBottom(int, int) noexcept;
};
}
